x = 400
y = 300
xs = 0
ys = 0
r = 0
cr = 0
ls = 0
carb = 1
rotate = false

function love.load()
  love.window.setTitle("Gravity Is Always Down My Feet, Right?")
  
  canvas = love.graphics.newCanvas(10, 20)
  love.graphics.setCanvas(canvas)
    love.graphics.rectangle("fill", 0, 0, 10, 20)
  love.graphics.setCanvas()
  
  local size = 10000
  trail = love.graphics.newCanvas(size, size)
  stars = love.graphics.newCanvas(size, size)
  love.graphics.setCanvas(stars)
    for i=1,size do
      love.graphics.points(math.random(stars:getWidth()), math.random(stars:getHeight()))
    end
    love.graphics.setColor(.7, .7, .7, 1)
    love.graphics.circle("fill", math.random(stars:getWidth()), math.random(stars:getHeight()), 40)
  love.graphics.setCanvas()
  
  love.physics.setMeter(64)
  world = love.physics.newWorld(0, 0, true)
  
  objects = {}
  
  objects.player = {}
  objects.player.body = love.physics.newBody(world, 10, 300, "dynamic")
  objects.player.shape = love.physics.newRectangleShape(0, 0, 20, 10)
  objects.player.fixture = love.physics.newFixture(objects.player.body, objects.player.shape, 10)
  
  objects.player.body:setAngularDamping(3)
  objects.player.body:setLinearDamping(3)
  
  objects.blocks = {}
  for i=1,0 do
    objects.blocks[i] = {}
    objects.blocks[i].body = love.physics.newBody(world, math.random(800), math.random(600), "dynamic")
    objects.blocks[i].shape = love.physics.newRectangleShape(0, 0, 10, 10)
    objects.blocks[i].fixture = love.physics.newFixture(objects.blocks[i].body, objects.blocks[i].shape, 10)
    objects.blocks[i].body:setSleepingAllowed(false)
  end
  
  objects.diamonds = {}
  for i=1,1000 do
    objects.diamonds[i] = {}
    objects.diamonds[i].rs = math.random(-100, 100)/200*math.pi
    objects.diamonds[i].x, objects.diamonds[i].y = math.random(size), math.random(size)
    objects.diamonds[i].body = love.physics.newBody(world, math.random(800), math.random(600), "dynamic")
    objects.diamonds[i].shape = love.physics.newRectangleShape(0, 0, 50, 50)
    objects.diamonds[i].fixture = love.physics.newFixture(objects.diamonds[i].body, objects.diamonds[i].shape, 100)
    objects.diamonds[i].body:setGravityScale(0)
    objects.diamonds[i].fixture:setMask(2, 3)
    objects.diamonds[i].fixture:setCategory(2)
  end
  
--  objects.wall1 = {}
--  objects.wall1.body = love.physics.newBody(world, 400, 625)
--  objects.wall1.shape = love.physics.newRectangleShape(800, 50)
--  objects.wall1.fixture = love.physics.newFixture(objects.wall1.body, objects.wall1.shape)
--  objects.wall1.fixture:setCategory(3)
  
--  objects.wall2 = {}
--  objects.wall2.body = love.physics.newBody(world, 400, -25)
--  objects.wall2.shape = love.physics.newRectangleShape(800, 50)
--  objects.wall2.fixture = love.physics.newFixture(objects.wall2.body, objects.wall2.shape)
--  objects.wall2.fixture:setCategory(3)
  
--  objects.wall3 = {}
--  objects.wall3.body = love.physics.newBody(world, 825, 300)
--  objects.wall3.shape = love.physics.newRectangleShape(50, 600)
--  objects.wall3.fixture = love.physics.newFixture(objects.wall3.body, objects.wall3.shape)
--  objects.wall3.fixture:setCategory(3)
  
  objects.wall4 = {}
  objects.wall4.body = love.physics.newBody(world, -25, 300)
  objects.wall4.shape = love.physics.newRectangleShape(50, 600)
  objects.wall4.fixture = love.physics.newFixture(objects.wall4.body, objects.wall4.shape)
  objects.wall4.fixture:setCategory(3)
end

function love.update(delta)
  dt = delta
  
  world:setGravity(-1000*math.cos(r), -1000*math.sin(r))
  world:update(dt)
  
  for i,v in ipairs(objects.diamonds) do
    v.body:setPosition(v.x, v.y)
  end
  
  r = objects.player.body:getAngle()
  x, y = objects.player.body:getPosition()
  
  if love.keyboard.isScancodeDown("w") and carb == 1 then 
    objects.player.body:applyLinearImpulse(1000*math.cos(r), 1000*math.sin(r))
    carb = 0
    rotate = not rotate
  elseif carb < 1 then carb = carb + dt else carb = 1 end
  
  xs, ys = objects.player.body:getLinearVelocity()
  ls = math.sqrt(xs^2 + ys^2)
  
  if love.keyboard.isScancodeDown("d") then 
    if not rotate then objects.player.body:applyForce(500*math.cos(r+math.pi/2), 500*math.sin(r+math.pi/2)) else objects.player.body:applyTorque(-200) end
  elseif love.keyboard.isScancodeDown("a") then 
    if not rotate then objects.player.body:applyForce(500*math.cos(r-math.pi/2), 500*math.sin(r-math.pi/2)) else objects.player.body:applyTorque(200) end
  end
  
  r = objects.player.body:getAngle()
  x, y = objects.player.body:getPosition()
end

function love.draw()
  love.graphics.setCanvas(trail)
    love.graphics.setBlendMode("multiply", "premultiplied")
    love.graphics.setColor(1, 1, 1, .9)
    love.graphics.rectangle("fill", x-400, y-400, 800, 800)
    love.graphics.setBlendMode("alpha")
    love.graphics.setColor(1, 1, 1, 1-carb)
    love.graphics.line(x, y, x-xs*dt, y-ys*dt)
  love.graphics.setCanvas()
  love.graphics.setColor(1, 1, 1, 1)
  
  love.graphics.push()
    love.graphics.translate(400, 300)
    love.graphics.rotate(-r-math.pi/2)
    love.graphics.translate(-x, -y)
    
    love.graphics.push()
      love.graphics.scale(.7)
      love.graphics.draw(stars, x, y)
    love.graphics.pop()
    
    love.graphics.draw(trail)
    love.graphics.draw(canvas, x, y, r+math.pi/2, 1, 1, 5, 10)
    
    love.graphics.line(0, 0, 0, 600)
    love.graphics.polygon("fill", objects.player.body:getWorldPoints(objects.player.shape:getPoints()))
    for i,v in ipairs(objects.diamonds) do love.graphics.polygon("fill", v.body:getWorldPoints(v.shape:getPoints())) end
    for i,v in ipairs(objects.blocks) do love.graphics.polygon("fill", v.body:getWorldPoints(v.shape:getPoints())) end
    
    love.graphics.setColor(0, 0, 0, 1)
    local px, py = objects.player.body:getWorldCenter()
    if rotate then 
      love.graphics.arc("line", "open", px, py, 3, math.pi/6, 5*math.pi/6) 
      love.graphics.arc("line", "open", px, py, 3, 7*math.pi/6, 11*math.pi/6) 
    else love.graphics.line(px-3, py, px+3, py) end
  love.graphics.pop()
  
  love.graphics.setColor(1, 1, 1, 1)
  love.graphics.print(love.timer.getFPS())
end

--function love.keypressed(key, scan)
--  if scan == "s" then rotate = not rotate end
--end